#include "macros.inc"

#define tmp r24
#define count r25
#define u16l r20
#define u16h r21
#define t16l r22
#define t16h r23

		.text


		.global	uuprintf_P
		.type		uuprintf_P, @function


uuprintf_P:								; Formatstring im Flash-ROM
		LOAD_X(r24, r25)				; X -> Ausgabe
		LOAD_Z(r22, r23)				; Z -> Formatstring
1:		LPM_R0_ZPLUS_NEXT
		mov tmp, r0
		tst tmp
		breq 2f
      cpi tmp, '%'
      breq 10f
      st X+, tmp
      rjmp 1b
2:		st X, r1
		ret


10:	push ZL							; Platz schaffen
		push ZH
		ldi ZL, lo8(.uuprintf_lt)	; Zeiger auf LookUp-Tabelle laden
		ldi ZH, hi8(.uuprintf_lt)
		ldi count, 4					; 16Bit -> 5Stellen -> 4 Durchgaenge
		clt
11:	ser tmp
		LPM_R0_ZPLUS_NEXT
		mov t16h, r0
		LPM_R0_ZPLUS_NEXT
		mov t16l, r0
12:	inc tmp
		sub u16l, t16l
		sbc u16h, t16h
		brcc 12b
		add u16l, t16l
		adc u16h, t16h
		brts 14f
		tst tmp
		breq 13f
		set
14:	subi tmp, -'0'
		st X+, tmp
13:	dec count
		brne 11b
		subi u16l, -'0'
		st X+, u16l
		pop ZH
		pop ZL
		rjmp 1b


;***	Lookup-Tabelle fuer 10-er Potenzen ****************************

.uuprintf_lt:
		.byte 0x27, 0x10
		.byte 0x03, 0xe8
		.byte 0x00, 0x64
		.byte 0x00, 0x0a



		.size uuprintf_P, . - uuprintf_P


